﻿namespace SampleEFCore8CodeMag;

public class Customer
{
    public int CustomerId { get; set; }
    public PersonName? Name { get; set; } //can't be nullable if you use ComplexProperty
    public DateOnly FirstPurchase { get; set; }
}

public class ShipLabel
{
    public int Id { get; set; }
    public PersonName? Name { get; set; } //can't be nullable if you use ComplexProperty
}


//Value Object as class with primary constructor
public class PersonName
{
    public PersonName(string firstName, string lastName)
    {
        FirstName = firstName;
        LastName = lastName;
    }
    public string FirstName { get; init; }
    public string LastName { get; init; }

    public override bool Equals(object? obj)
    {
        return obj is PersonName name &&
               FirstName == name.FirstName &&
               LastName == name.LastName;
    }

    public override int GetHashCode()
    {
        return HashCode.Combine(FirstName, LastName);
    }
}

