﻿using Microsoft.EntityFrameworkCore;

namespace SampleEFCore8CodeMag;

public class MyDbContext:DbContext
{
    public MyDbContext(DbContextOptions options) : base(options)
    {
    }

    public DbSet<Customer> Customers { get; set; }
    public DbSet<ShipLabel> Labels { get; set; }

    override protected void OnModelCreating(ModelBuilder modelBuilder)
    {
        //see what happens if you comment out the ownsone methods and enable the complexproperty methods
        modelBuilder.Entity<Customer>().OwnsOne(c => c.Name);
        modelBuilder.Entity<ShipLabel>().OwnsOne(l => l.Name);
        //modelBuilder.Entity<Customer>().ComplexProperty(c => c.Name);  
        //modelBuilder.Entity<ShipLabel>().ComplexProperty(l => l.Name);
    }
}
