﻿namespace SampleEFCore8CodeMag;

public class Customer
{
    public int CustomerId { get; set; }
    public PersonName Name { get; set; } //can't be nullable if you use ComplexProperty
    public DateOnly FirstPurchase { get; set; }
}

public class ShipLabel
{
    public int Id { get; set; }
    public PersonName Name { get; set; } //can't be nullable if you use ComplexProperty
}

//readonly record struct with properties and a primary constructor
public readonly record struct PersonName
{
    public PersonName(string firstName, string lastName)

    {
        FirstName = firstName;
        LastName = lastName;
    }

    public string FirstName { get; init; }
    public string LastName { get; init; }

    public string FullName => $"{FirstName} {LastName}";

}